<?
/* SEIFT : Moteur de recherche en fulltext */

// Le rpertoire de recherche (avec / final)
$conf["url"] = "vieux_site/";

// L'url du rpertoire o l'on cherche (sans le / final)
$conf["web_url"] = "http://titine.free.fr/projets/seift/demo/vieux_site";

// Extension des fichiers recherch sous forme d'expression rgulire ;)
$conf["ext"]="\.html?$";

// Taille des lignes extraites
$conf["extraitWidth"] = 90;

// Nbre de ligne extraites
$conf["nbreLigne"] = 3;

// Affiche t-on le nombre de rsultat trouv par page ? 0:Non
$conf["is_occurence"] = 1;

// Nbre de pages trouves par page
if (isset($nbr_par_page) && $nbr_par_page != ""){
	$conf["nbr_par_page"] = $nbr_par_page;
}else{
	$conf["nbr_par_page"] = 10;
}

// Afficher le header ?
$conf["is_header"] = 1;

// Respecte la casse ?
$conf["is_casesensitive"]=$is_casesensitive;




//***************** FONCTIONS DIVERSES **********

// Verifier l'extension
function verifierExt($file,$ext){
	return ereg("$ext",$file);
}

// fonction de comparaison pour le tri des rsultats
function compare($a,$b){
	if ($a["n"]==$b["n"]){
		if ($a["nb_occurence"]==$b["nb_occurence"]) return 0;
		return ($a["nb_occurence"]>$b["nb_occurence"])? -1 : 1;
	}else{
		return ($a["n"]<$b["n"])? -1 : 1;
	}
}

// Fonction pour Traiter les accents une fois le code pur des balises HTML
function traitementAccentsHTML($text){
	$text = ereg_replace("&#224;","",$text);
	$text = ereg_replace("&agrave;","",$text);
	$text = ereg_replace("&#226;" ,"",$text);
	$text = ereg_replace("&acirc;" ,"",$text);
	$text = ereg_replace("&#228;" ,"",$text);
	$text = ereg_replace("&auml;" ,"",$text);
	$text = ereg_replace("&#230;" ,"ae",$text);
	$text = ereg_replace("&aelig;" ,"ae",$text);
	$text = ereg_replace("&#231;" ,"",$text);
	$text = ereg_replace("&ccedil;" ,"",$text);
	$text = ereg_replace("&#232;" ,"",$text);
	$text = ereg_replace("&egrave;" ,"",$text);
	$text = ereg_replace("&#233;" ,"",$text);
	$text = ereg_replace("&eacute;" ,"",$text);
	$text = ereg_replace("&#234;" ,"",$text);
	$text = ereg_replace("&ecirc;" ,"",$text);
	$text = ereg_replace("&#235;" ,"",$text);
	$text = ereg_replace("&euml;" ,"",$text);
	$text = ereg_replace("&#238;" ,"",$text);
	$text = ereg_replace("&icirc;" ,"",$text);
	$text = ereg_replace("&#239;" ,"",$text);
	$text = ereg_replace("&iuml;" ,"",$text);
	$text = ereg_replace("&#244;" ,"",$text);
	$text = ereg_replace("&ocirc;" ,"",$text);
	$text = ereg_replace("&#249;" ,"",$text);
	$text = ereg_replace("&ugrave;" ,"",$text);
	$text = ereg_replace("&#251;" ,"",$text);
	$text = ereg_replace("&ucirc;" ,"",$text);
	$text = ereg_replace("&#174;" ,"@",$text);
	$text = ereg_replace("&reg;" ,"@",$text);
	$text = ereg_replace("&nbsp;" ," ",$text);
	$text = ereg_replace("&lt;" ,"<",$text);
	$text = ereg_replace("&#139;" ,"<",$text);
	$text = ereg_replace("&gt;" ,">",$text);
	$text = ereg_replace("&#155;" ,">",$text);
	$text = ereg_replace("&quot;" ,'"',$text);
	$text = ereg_replace("&#34;" ,'"',$text);
	$text = ereg_replace("&#36;" ,"$",$text);
	$text = ereg_replace("&amp;" ,"&",$text);
	$text = ereg_replace("&#38;" ,"&",$text);
	$text = ereg_replace("&#39;" ,"'",$text);
	$text = ereg_replace("&trade;" ,"TM",$text);
	$text = ereg_replace("&#153;" ,"TM",$text);
	$text = ereg_replace("&#156;" ,"oe",$text);
	$text = ereg_replace("&oelig;" ,"oe",$text);
	$text = ereg_replace("&#146;" ,"'",$text);
	
	// Plus gnrale pour les accents farfelues ;-)
	$text = ereg_replace("&(.)[^;]*;","\\1",$text);
	return $text;
} 

// Fonction filtre pour les diffrents formats
function filtre($text,$type){
	
	if ($type == "html" || $type == "htm"){
		// On ajoute des espaces o il en faut
		$text = str_replace("<br", " <br", $text);
		$text = str_replace("<Br", " <Br", $text);
		$text = str_replace("<BR", " <BR", $text);
		$text = str_replace("<p", " <p", $text);
		$text = str_replace("<P", " <P", $text);
		// pour Pb avec feuille de style
		$text = ereg_replace("<style.*</style>"," ",$text);
		$text = eregi_replace("<script.*</script>"," ",$text);
					
					
		$text = strip_tags($text);
		$text = traitementAccentsHTML($text);
		$text = ereg_replace("[[:space:]][[:space:]]+", " ", $text);

	} else if ($type == "txt"){
		#rien
	}else{
		# ???
	}
	return $text;
}


// Fonction de recherche pour un mot
// argument : le mot, l'url du rpertoire  traiter, la configuration $conf et le nb_now : nombre de pages dj trouves (0 au dpart)

function recherche($search,$url,$nb_now,$n) {
	global $conf;
	global $tb_resultat;
	
	$nb=$nb_now;
	
	$rep = opendir("$url");
	$search = trim($search);
	if ($search == ""){
		return 0;
	}
	
	while($dir = readdir($rep)) {
		// On exclue les rpertoire . et ..
		if ($dir == "." || $dir == "..") continue;
		
		// si c'est un sous-rpertoire, on continue rcursivement
		if(is_dir("$url$dir/")){  
			$nb = recherche($search,$url.$dir."/",$nb,$n);
		}
		
		// Pas la bonne extension
		if(! verifierExt($dir,$conf["ext"])) continue;
		
		if(!($fichier = file($url.$dir))) {
			// Impossible de lire le fichier
			echo "<!-- Impossible d'ouvrir ".$url.$dir."-->";
			continue;
		}else {
			// Mise en forme du texte sur lequel on bosse
			$text = implode($fichier, " ");
			$textinit=$text;
			
			// On filtre en fonction de l'extension
			$text=filtre($text,ereg_replace(".*\.([^\.])","\\1",$dir));
			
			if($conf["is_casesensitive"]){
				$text2=$text;
				$search2=$search;
			}else{
				// On passe le texte en minuscule
				$text2 =strtolower($text);
				$search2 = strtolower($search);
			}
			
			$size = strlen($text);
			
			// Rcupration du titre si c'est du html
			$debut_titre = strpos($textinit, "<title>") + 7;
			$fin_titre = strpos($textinit, "</title>");
			$longueur = $fin_titre - $debut_titre;
			if ($fin_titre != "" && $longueur != 0) {
				$title = substr($textinit, $debut_titre, $longueur);
				if(trim($title)== "") $title = $dir;
			} else {
				// On essaye avec TITLE
				$debut_titre = strpos($textinit, "<TITLE>") + 7;
				$fin_titre = strpos($textinit, "</TITLE>");
				$longueur = $fin_titre - $debut_titre;
				if ($fin_titre != "" && $longueur != 0) {
					$title = substr($textinit, $debut_titre, $longueur);
					if(trim($title)== "") $title = $dir;
				}else{
					// Sinon, titre = nom du fichier
			 		$title = $dir;
				}
			}
			
			$pos = 0;       
			$occurence = 0;
			$encore=1;
			$description=""; // Les lignes de description
			
			while(1){
				$resultat = strpos($text2,$search2,$pos);
				
				if (!$resultat){ // Plus de rsultat dans la page
					break;
				} else {
					// Une occurence de +
					$occurence++;
					$newpos = $resultat;
								
					//On affiche Le titre si c'est la 1ere occurrence
					if ($occurence == 1){
						$nb++;
						$description = "<A HREF='".htmlentities($url.$dir)."'><b>".htmlentities(traitementAccentsHTML($title))."</b> : </A><BR>\n";
					}
					
					// On affiche les extraits
					if (($occurence <= $conf["nbreLigne"])){ // Si l'on doit afficher l'extrait (nbre trouv < nbre  afficher)
						// On extrait le texte autour du mot
						$demiExtraitWidth = $conf["extraitWidth"] / 2;
						$gpos = ($newpos - $demiExtraitWidth < 0) ? 0 : $newpos - $demiExtraitWidth;
						$dpos = ($gpos + $conf["extraitWidth"] > $size) ? $size : $gpos + $conf["extraitWidth"];
						$gpos = ($dpos < $size) ? $gpos : (($dpos - $conf["extraitWidth"] < 1) ? 0 : $dpos - $conf["extraitWidth"]);																																
						
						// On le sort en enlevant les espaces du dbut
						$extrait = trim(substr($text, $gpos, $dpos - $gpos));
						
						$ligne = eregi_replace("(".$search.")","<b>\\1</b>",$extrait);
						if($gpos != 0) $ligne = eregi_replace("^[^ ]* ","",$ligne); // On enlve les mots coups en bout
						if($dpos != $size) $ligne = eregi_replace("[^ ]*$","",$ligne); // et en fin
						
						$description .=  "&nbsp;&nbsp;&nbsp;&nbsp;... ".$ligne."... <br>\n";
						
						// TODO compromis entre avoir le bon nombre d'occurence ou rpter 2 fois ma mme chose :(
						$pos = $dpos; // Position = position de droite
						// $pos=$newpos+strlen($search); // Juste derrire le 1er rsultat
						
					} else if(!$conf["is_occurence"]){ // Si on ne veut pas trier par occurence
						break;
					} else { // sinon on continue
						$pos=$newpos+strlen($search);
					}
				}
			}
			// Fin de la recherche
			// On stocke le nombre d'occurences
			if($occurence != 0 ) {
				$description .= "<font size=2 color='#777700'>".htmlentities($conf["web_url"])."/".htmlentities($dir)." </font>";
				
				if ($conf["is_occurence"]){
					$description .= "<font size=2 color='#777700'><I> - <U>".htmlentities($search2)."</U> : $occurence</I></font>\n";
				}
			}
			
			$page=array("n"=>$n,"mot"=>$search,"nb_occurence"=>$occurence,"description"=>$description);
			if($description != ""){ // On stocke dans le tableau de rsultat
				$tb_resultat[count($tb_resultat)]=$page; // On le mets  la fin du tableau
			}
		}
	}
	closedir($rep);
	return $nb;
}

// Affichage des rsultats
function afficher($tb_resultat){
	global $conf;
	global $nb_init;  // A partir de quel resultat on commence l'affichage
	usort($tb_resultat,compare); // On tri en fonction du nbre d'occurences
	while(list($key,$value) = each($tb_resultat)) {
		if (($key+1) > $nb_init && ($key+1)<=($nb_init+$conf["nbr_par_page"])){ 
			echo "<b>".($key+1)."</b>. ".$value['description']."\n<br><br>";
		}
	}
}

// Affiche la barre de navigation entre les pages
function choixpage($nb_init,$nb_total,$searchinit) {
	global $conf;
	// Boutons previous
	if($nb_init>0)
		echo " <a href='index.php3?nbr_par_page=".$nbr_par_page."is_casesensitive=".$conf["is_casesensitive"]."&search=".rawurlencode($searchinit)."&nb_init=".($nb_init-$conf["nbr_par_page"])."&nbr_par_page=".$conf["nbr_par_page"]."'>&lt;&lt;&lt;previous</A> ";
	
	$imax= floor(($nb_total-1)/$conf["nbr_par_page"])+1;
	if ($imax!=1){
		for($i=1;$i <= $imax;$i++){
			if($nb_init == (($i-1)*$conf["nbr_par_page"])){
				echo " <b>$i</b> ";
			} else {
				echo " <a href='index.php3?nbr_par_page=".$nbr_par_page."is_casesensitive=".$conf["is_casesensitive"]."&search=".rawurlencode($searchinit)."&nb_init=".(($i-1)*$conf["nbr_par_page"])."&nbr_par_page=".$conf["nbr_par_page"]."'>$i</A> ";
			}
		}
	}

	// Bouton next
	if($nb_init+$conf["nbr_par_page"]<$nb_total)
		echo " <a href='index.php3?nbr_par_page=".$nbr_par_page."is_casesensitive=".$conf["$is_casesensitive"]."&search=".rawurlencode($searchinit)."&nb_init=".($nb_init+$conf["nbr_par_page"])."&nbr_par_page=".$conf["nbr_par_page"]."'>next&gt;&gt;&gt;</A> ";
	
	echo "<br>\n";
}

//**************************************************************************
//****************************************** Dbut du code *****************

if (!(isset($search) && $search != "") || $conf["is_header"]) { // Le Formulaire
	
	echo "<html><head><title>Moteur de recherche</title></head><body>
	<form method='POST' action='index.php3'>
		<h2><b>Moteur de Recherche</b></h2>
		<br>
		Entrez le mot que vous souhaitez rechercher :<br>
		<input type='text' name='search' value='$search' size='26'>
		<select name='nbr_par_page' size=1>
		<option value=5>5 rsultats
		<option value=10 selected>10 rsultats
		<option value=20>20 rsultats
		<option value=50>50 rsultats
		</select>		
		<input type='submit' value='Rechercher'>
		<br>
		<input type='checkbox' value='1' name='is_casesensitive'> Respecter les majuscules/minuscules
	</form>";

} 

if (isset($search) && $search != "") {  // Si le champ "recherche" a t rempli
	
	// On enlve les espaces de fin et dbut
	$search=rawurldecode($search);
	$searchinit=$search;
	$search=trim($search);

	
	// Si il y a plusieurs mots ?
	$mots = split("[' ]",$search,100);
	
	// initialisation du nbre de fois que le mot a t trouv
	$nb = 0;

	// Chrono ?
	$seconde0=date("U");
	
	// Recherche sur tout
	$nb = recherche($search,$conf["url"],0,0);
	
	// Recherche sur chaque mot si plus d'un mot
	if (count($mots) > 1){
		for($i=0; $i < count($mots); $i++){
				$monMot = $mots[$i];
				// On supprime les mots de liaisons usuels
				if (preg_match("/^((.)|(..)|(les)|(une)|(des))$/",$monMot)){
					// Rien
				}else {
					$nb = recherche($monMot,$conf["url"],$nb,$i+1);
				}
		}
	}
	$nb_total = $nb;
	
	$seconde1=date("U");
	$temps= ($seconde1-$seconde0);
	
	if (isset($tb_resultat) || $tb_resultat != "") 
	{
		echo "<hr>";
		echo "<font size=2 color=red >$nb_total pages trouves en $temps secondes</font><br><br>\n";
		
		choixpage($nb_init,$nb_total, $searchinit);
		
		echo "<br>\n";
		
		if (isset($tb_resultat) || $tb_resultat != "") 
			afficher($tb_resultat);

		choixpage($nb_init,$nb_total, $searchinit);
		
	}else{ 
		echo " <I>Nous sommes dsols mais aucune page ne correspond  votre recherche</I><BR>\n<BR>\n";
	}

				
} 

echo "<br></body></html>";

